open Util
open Pp (* pour msgnl *)
open Tactics (* pour intros *)
open Global
open Names
open Term
open Proof_type
open Hipattern
open Tacmach
open Tacticals
open Tactics
open Coqlib
open Reductionops
open Rawterm
open Nameops
open Mlutil
open Printer 
open Hiddentac


let string_of_name na = 
  (string_of_id (id_of_name na))




let myassert name typ term gl =
 (*  msgnl (prtype term); *)
  tclTHENFIRST (assert_tac true name typ)
    (exact_no_check term) gl


let named_lamn n env b =
  let rec lamrec = function
    | (0, env, b)        -> b
    | (n, ((v,t)::l), b) -> lamrec (n-1,  l, mkNamedLambda v t b)
    | _ -> assert false
  in 
  lamrec (n,env,b)
let compose_nlam l b = named_lamn (List.length l) l b


let elimand gl =
  let new_ident strid taboo gl = fresh_id taboo (id_of_string strid) gl in
  let env = pf_env gl in
  let sigma = project gl in

  let rec elimnd hyp_id typ taboo hyps app lam gl =
    begin
      match kind_of_term typ with
      | Prod (na,t,u)  ->
	  let h = new_ident "h" taboo gl in
	  let name = new_ident "h" (h::taboo) gl in
	  elimnd hyp_id u ([name; h] @ taboo) 
	    ((Name h,t)::hyps) ((mkVar name)::app) 
	    ((name, t)::lam) gl
      | App (c, carr) when is_conjunction c -> 
	  let ind=( match kind_of_term c
	  with | Ind i -> i 
	| _ ->assert false (*is_conjunction...*)) 
	  in
	  (*msgnl (str "on destructure"));  *)
	  (begin
	    let h = new_ident "h" taboo gl in 
	    let a = new_ident "A" (taboo @ [h]) gl in
	    let b = new_ident "B" (taboo @ [a; h]) gl in
	    (true, fun gl ->(tclTHEN 
	       (myassert Anonymous  
		  (compose_prod hyps carr.(0))
		  (compose_nlam lam
		     (mkNamedLetIn h  
			(applist 
			   ((mkVar hyp_id), 
			    List.rev app))
			typ
			(mkCase ({ci_ind=ind; 
				  ci_npar=2; 
				  ci_pp_info={ind_nargs=1; 
					      style=LetStyle;
					      source=[|RegularPat|]}}, 
				 (mkLambda (Anonymous, typ, carr.(0))),
				 mkVar h,
				 [| (mkNamedLambda a carr.(0) 
				       (mkNamedLambda b carr.(1)
					  (mkVar a)))|])))))
	       (tclTHEN
		  (myassert Anonymous  
		     (compose_prod hyps carr.(1))
		     (compose_nlam lam
			(mkNamedLetIn h  (applist ((mkVar hyp_id), List.rev app)) typ
			   (mkCase ({ci_ind=ind; 
				     ci_npar=2; 
				     ci_pp_info={ind_nargs=1; 
						 style=LetStyle;
						 source=[|RegularPat|]}}, 
				    (mkLambda (Anonymous, typ, carr.(1))),
				    mkVar h,
				    [| (mkNamedLambda a carr.(0) 
					  (mkNamedLambda b carr.(1)
					     (mkVar b)))|])))))
		  (clear [hyp_id]) ))gl )
	  end)
      | _ -> (false, fun gl -> tclIDTAC gl)
    end
  and seek_neg l w gl = 
    begin 
      match l with
      | [] -> if w then
	  tclIDTAC gl
	    else error "No more and's"
      | (id,ind,typ)::rest -> (* msgnl (str (string_of_id id));
	  msgnl (prtype typ); *)
	  let typ = whd_betadeltaiota env sigma typ in
	  let worked, tac = (elimnd id typ [] [] [] []) gl in
	  (tclTHEN  tac
	     (seek_neg rest (worked or w))) gl
    end in
  seek_neg (pf_hyps gl) false gl






TACTIC EXTEND Elimand
| ["elimAnd"] -> [ tclREPEAT elimand ]
END  

