open Util
open Pp (* pour msgnl *)
open Tactics (* pour intros *)
open Global
open Names
open Term
open Proof_type
open Hipattern
open Tacmach
open Tacticals
open Tactics
open Coqlib
open Reductionops
open Rawterm
open Nameops
open Mlutil
open Printer 
open Hiddentac





let myassert name typ term gl = (* msgnl (prtype term); msgnl (prtype typ);*)
  (*tclIDTAC *)(tclTHENFIRST (assert_tac true name typ) (exact_no_check term)) gl
  
(* lamn n [xn:Tn;..;x1:T1;Gamma] b = [x1:T1]..[xn:Tn]b *)
let named_lamn n env b =
  let rec lamrec = function
    | (0, env, b)        -> b
    | (n, ((v,t)::l), b) -> lamrec (n-1,  l, mkNamedLambda v t b)
    | _ -> assert false
  in 
  lamrec (n,env,b)
let compose_nlam l b = named_lamn (List.length l) l b

let elimor_adv gl =
  let new_ident strid tboo gl =  fresh_id tboo (id_of_string strid) gl in
  let or_intror ter =  begin
    match kind_of_term ter with
    | Ind ind -> 
       	mkConstruct (ith_constructor_of_inductive (ind) 2) 
    | _ -> mkProp
  end in
  let or_introl ter =  begin
    (* let (mi, omi) = (lookup_inductive mind) in *)
    match kind_of_term ter with
    | Ind ind -> 
       	mkConstruct (ith_constructor_of_inductive (ind) 1) 
    | _ -> mkProp
  end in
  let idfun a = a in
  let env = pf_env gl in
  let sigma = project gl in
  let rec elimrec_noclear hyp_id  typ taboo (prod, lamb, app, tail) (prod_new, lamb_new, app_new) = 
    begin
    match kind_of_term typ  with
    | Prod (na,t,u) -> 
	begin
	let h = new_ident "h" taboo gl in
	(match kind_of_term t with 
	| App (c, carr) when is_disjunction c -> 
	    
	    (tclTHEN 
	       (elimrec_noclear hyp_id u (h::taboo) 
		  ((na, carr.(0))::(prod_new @ prod), 
		   ( h, carr.(0))::(lamb_new @ lamb), 
		   (mkApp ((or_introl c), [|carr.(0); carr.(1); (mkVar h)|]))::(app_new @ app),
		   u)
		  ([],[],[]))
	       (elimrec_noclear hyp_id u (h::taboo) 
		  ((na, carr.(1))::(prod_new @ prod), 
		   ( h, carr.(1))::(lamb_new @ lamb), 
		   (mkApp ((or_intror c), [|carr.(0); carr.(1); (mkVar h)|]))::(app_new @ app),
		   u)
		  ([],[],[])))
	| _  ->	elimrec_noclear  hyp_id u (h::taboo)(prod, lamb, app, tail) 
	      ((na, t)::prod_new, ( h,t)::lamb_new,(mkVar h)::app_new))
	end
    | _ -> myassert Anonymous
		  (compose_prod prod  tail)
		  (compose_nlam   lamb (applist ((mkVar  hyp_id), List.rev app)))
    end in
 (* let rec build_term typ id  = 
    begin
    match kind_of_term typ with 
    | App (c, carr) when is_disjunction c ->
	tclTHEN 
	  (elimrec_noclear hyp_id u (h::taboo) 
	     ((na, carr.(0)):: prod, 
	      ( h, carr.(0)):: lamb, 
	      (mkApp ((or_introl c), [|carr.(0); carr.(1); (mkVar h)|]))::app,
	      u)
	     ([],[],[]))
	  build_term
    | _ -> tclTHEN 
	  (elimrec_noclear hyp_id u (h::taboo) 
	     ((na, carr.(0)):: prod, 
	      ( h, carr.(0)):: lamb, 
	      (mkApp ((or_introl c), [|carr.(0); carr.(1); (mkVar h)|]))::app,
	      u)
	     ([],[],[]))
    end *)
  let rec elimrec hyp_id   typ taboo (prod, lamb, app)  = 
    match kind_of_term typ  with
    | Prod (na,t,u) -> 
	begin
	let h = new_ident "h" taboo gl in
	(match kind_of_term t with 
	| App (c, carr) when is_disjunction c -> 
	   
	    (true, 
	     (fun gl -> 
	       (tclTHEN (tclTHEN 
			   (elimrec_noclear hyp_id u (h::taboo) 
			      ((na, carr.(0)):: prod, 
			       ( h, carr.(0)):: lamb, 
			       (mkApp ((or_introl c), [|carr.(0); carr.(1); (mkVar h)|]))::app,
			       u)
			      ([],[],[]))
			   (elimrec_noclear hyp_id u (h::taboo) 
			      ((na, carr.(1))::  prod, 
			       ( h, carr.(1)):: lamb, 
			       (mkApp ((or_intror c), [|carr.(0); carr.(1); (mkVar h)|])):: app,
					      u)
					     ([],[],[])))
				 (clear [hyp_id])) gl))
	| _  ->	elimrec hyp_id  u (h::taboo) ((na, t)::prod, ( h,t)::lamb,(mkVar h)::app))
	end
    | _ -> (false,  (fun gl -> (tclIDTAC gl)))

  and seek_or l worked gl = match l with
  | [] -> (if worked then (tclIDTAC gl) else (error "elimor: I can't break anymore or's."))
  | (id,binds,typ)::rest ->
      let typ = whd_betadeltaiota env sigma typ in
      let a, g = (elimrec id  typ [] ([], [], [])) in
      (tclTHEN  g (seek_or rest (a or worked))) gl
  in
   (seek_or (pf_hyps gl) false) gl


TACTIC EXTEND ElimOr
| ["elimOr"] -> [  tclREPEAT elimor_adv ]
END 


